<?php
/** 
*
* @package 123 Flashchat
* @version $Id: acp_fchat.php, 2010/04/26
* @copyright (c) 2010 TOPCMM
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_fchat
{
	var $u_action;
    /**
	* Constructor
	*/
	function main($id, $mode)
	{
		global $config, $db, $user, $auth, $template;
		global $phpbb_root_path, $phpEx;

        $this->tpl_name 	= 'acp_fchat';
        $this->page_title 	= $user->lang(FC_TITLE);
        switch ($mode)
		{
			case 'config':
        		$this->configuration();
		    break;
			case 'moreconfig':
			    $template->assign_vars(array(  
                        'S_FC_ADMIN'            => true,  
                        'S_FC_SERVER'           => $config['fc_server'],  
                        'U_FC_ADMIN'            => $config['fc_client_loc'] . 'admin_123flashchat.swf?init_host='.$config['fc_server_host'].'&init_port='.$config['fc_server_port']."&init_user=".rawurlencode($user->data['username'])."&init_password=".$user->data['user_password'] . (($config['fc_server'] == 1) ? "&init_group=" . $config['fc_group'] : ""),
                        'U_ACTION'				=> $this->u_action,
                )); 
			break;
		}
		add_form_key('acp_fchat');
    }

	/**
	* 123 Flash Chat  Config
	*/
	function configuration()
	{
        ini_set("default_socket_timeout",3);
		global $cache, $config, $db, $user, $auth, $template;
		global $phpbb_root_path, $phpEx;
		$s_own_loc = $this -> validate_server('127.0.0.1', 51127);
		$c_own_loc = $this -> validate_client('http://127.0.0.1:35555/');
		$c_loc = $s_own_loc || $c_own_loc;
		$submit = (isset($_POST['submit'])) ? true : false;
        // when submitted
		if ($submit)
		{
	        $error = array();
	        $fc_row['server'] = request_var('server', 2);
	        switch ($fc_row['server'])
	        {
	            case 0:
                    $fc_row['server_host'] = $config['server_name'];
                    $fc_row['server_port'] = 51127;
                    $fc_row['http_port'] = 35555;
                    $fc_row['api_url'] = 'http://' . $config['server_name'] . ':' . $fc_row['http_port'] . '/';
                    $fc_row['client_loc'] = 'http://' . $config['server_name'] . ':' . $fc_row['http_port'] . '/';
	                if ($c_loc)
	                {
	                    $fc_row['server_host'] = request_var('s_host', '');
	                    $fc_row['server_port'] = request_var('s_port', 51127);
	                    $fc_row['http_port'] = request_var('s_http_port', 35555);
	                    $fc_row['api_url'] = 'http://' . $fc_row['server_host'] . ':' . $fc_row['http_port'] . '/'; 
	                    $fc_row['client_loc'] = $fc_row['api_url'];
	                    $s_own_loc = $this -> validate_server($fc_row['server_host'], $fc_row['server_port']);
	                    $c_own_loc = $this -> validate_client($fc_row['client_loc']);
	                    $da = $this -> validate_data_api($fc_row['api_url'] . 'online.js');
	                    if ($s_own_loc)
	                    {
	                        $error[] = 'FC_SERVER_ERROR';
	                    }
	                    if ($da || $c_own_loc)
	                    {
	                        $error[] = 'FC_HTTP_ERROR';
	                    }
	                }
	                $fc_row['client'] = request_var('client', 0);
	                if (!$fc_row['client'])
	                {
	                    $fc_row['client_skin'] = request_var('c_skin', '');
	                }
	                break;
	            case 1:
	                $fc_row['client_loc'] = request_var('c_location', '') . (substr(request_var('c_location', ''),-1,1) != '/' ? '/' : '');
	                $fc_row['server_host'] = parse_url($fc_row['client_loc'], PHP_URL_HOST);
	                if ($content = @file_get_contents($fc_row['client_loc']))
	                {
	                    preg_match('/init_port=([0-9]*)/', $content, $matches);
	                    $fc_row['server_port'] = $matches[1];
	                }
	                $fc_row['api_url'] = 'http://' . $fc_row['server_host'] . '/';
	                $fc_row['group'] = substr(parse_url($fc_row['client_loc'], PHP_URL_PATH),1,-1);
	                $c_own_loc = $this -> validate_client($fc_row['client_loc']);
	                $da = $this -> validate_data_api($fc_row['api_url'] . 'online.js?group=' . $fc_row['group']);
	                if ($c_own_loc or $da)
	                {
	                    $error[] = 'FC_CLIENT_LOC_ERROR';
	                }
	                $fc_row['client'] = request_var('client', 0);
	                if (!$fc_row['client'])
	                {
	                    $fc_row['client_skin'] = request_var('c_skin', '');
	                }
	                break;
                case 2:
                    $fc_row['room'] = request_var('room','') ? request_var('room','') : $config['server_name'];
                    $fc_row['client'] = 0;
                    $fc_row['client_skin'] = request_var('c_skin', '');
                    $fc_array['room'] = array('string', false, 1, 50);
                    break;
	        }
			if ($fc_row['status'] = request_var('status', 0))
			{
			    $fc_row['room_list'] = request_var('room_list', 0);
			    $fc_row['user_list'] = request_var('user_list', 0);
			}

			$fc_row['client_embed'] = request_var('c_embed', 0);

			if (request_var('c_full', 0))
            {
                $fc_row['client_width'] = '100%';
                $fc_row['client_height'] = '100%';
			 }
			 else
			 {
			     $fc_row['client_width'] = request_var('c_width', 0) ? request_var('c_width', 0) : 800;
			     $fc_row['client_height'] = request_var('c_height', 0) ? request_var('c_height', 0) : 600;
			     $fc_array['client_width'] = array('num', false, 0, 2000);
			     $fc_array['client_height'] = array('num', false, 0, 2000);
			 }
			$fc_row['client_lang'] = request_var('c_lang', '');
			if (!function_exists('validate_data'))
			{
				include($phpbb_root_path . 'includes/functions_user.' . $phpEx);
			}
			if ($fc_array)
			{
			    $error = array_merge($error,validate_data($fc_row, $fc_array));
			}
			if (!check_form_key('acp_fchat'))
			{
				$error[] = 'FORM_INVALID';
			}
			if (!sizeof($error))
			{
				foreach ($fc_row as $config_name => $config_value)
				{
                    set_config('fc_' . $config_name, $config_value, true);
				}

			    add_log('admin','FC_CONFIG_UPDATE');

				trigger_error($user->lang['FC_CONFIG_SAVED'] . adm_back_link($this->u_action));
			}
			// Replace "error" strings with their real, localised form
			$error = preg_replace('#^([A-Z_]+)$#e', "(!empty(\$user->lang['\\1'])) ? \$user->lang['\\1'] : '\\1'", $error);			
		}
        // 123 Flash Chat Server Download OS(win/darwin/linux) detected
        $fc_download_url = 'http://www.123flashchat.com/download-now.html?p=123flashchat.' . ((PATH_SEPARATOR==':') ? (stristr(PHP_OS, 'darwin') ?  'dmg' : 'sh') : 'exe');
		$template->assign_vars(array(
			'S_FC_CONFIG'           => true,	    
            'S_FC_SERVER'           => isset($_POST['server']) ? $fc_row['server'] : $config['fc_server'],
            'FC_SERVER_HOST'        => isset($_POST['s_host']) ? $fc_row['server_host'] : $config['fc_server_host'],
            'FC_SERVER_PORT'        => isset($_POST['s_port']) ? $fc_row['server_port'] : $config['fc_server_port'],
            'FC_HTTP_PORT'          => isset($_POST['s_http_port']) ? $fc_row['http_port'] : $config['fc_http_port'],
            'FC_DOWNLOAD_URL'       => $fc_download_url,
            'S_FC_CLIENT_OWN_LOCATION'    => $c_loc,
            'FC_CLIENT_LOCATION'    => isset($_POST['c_location']) ? $fc_row['client_loc'] : $config['fc_client_loc'],
            'FC_ROOM'               => isset($_POST['room']) ? $fc_row['room'] : $config['fc_room'],
            'U_FC_LOGIN_CHAT'       => 'http://' . $config['server_name'] . (($config['script_path'] == '/') ? '' : $config['script_path']) . '/login_chat.php?username=%username%&password=%password%',
            'S_FC_STATUS'           => isset($_POST['status']) ? $fc_row['status'] : $config['fc_status'],
            'S_FC_ROOM_LIST'        => isset($_POST['room_list']) ? $fc_row['room_list'] : $config['fc_room_list'],
            'S_FC_USER_LIST'        => isset($_POST['user_list']) ? $fc_row['user_list'] : $config['fc_user_list'],
            'S_FC_CLIENT'           => isset($_POST['client']) ? $fc_row['client'] : $config['fc_client'],
			'S_FC_EMBED'    	    => isset($_POST['c_embed']) ? $fc_row['client_embed'] : $config['fc_client_embed'],
			'S_FC_FULL'    	        => isset($_POST['c_full']) ? request_var('c_full', 0) : (($config['fc_client_height'] == '100%') ? 1 : 0),
			'FC_CLIENT_HEIGHT'    	=> isset($_POST['c_height']) ? (($fc_row['client_height'] != '100%') ? $fc_row['client_height'] : '') : (($config['fc_client_height'] != '100%') ? $config['fc_client_height'] : ''),
			'FC_CLIENT_WIDTH'    	=> isset($_POST['c_width']) ? (($fc_row['client_width'] != '100%') ? $fc_row['client_width'] : '') : (($config['fc_client_width'] != '100%') ? $config['fc_client_width'] : ''),
			'FC_CLIENT_SKIN'     	=> $fc_row['client_skin'] ? $fc_row['client_skin'] : $config['fc_client_skin'],
			'FC_CLIENT_LANG'     	=> isset($_POST['c_lang']) ? $fc_row['client_lang'] : $config['fc_client_lang'],
			'FC_ERROR'				=> isset($error) ? ((sizeof($error)) ? implode('<br />', $error) : '') : '',
			'U_ACTION'				=> $this->u_action
		));
    }
    /**
	* Check 123 FlashChat Server Config
	* @parm $host   Chat Server Host
	* @parm $port   Chat Server Port
	* @return integer config status
	*/
    function validate_server($host, $port)
    {   $s_own_loc = 1;
        $apiCommand = '<Init/>';
        $resultDoc = "";
        $fp = @fsockopen($host, $port, $errno, $errstr, 2);
        if($fp)
        {
            fputs($fp,$apiCommand."\0");
            while (!feof($fp))
            {
                $resultDoc .= fgets($fp, 1024);
                $resultDoc = rtrim($resultDoc);
            }
            $parser = xml_parser_create("UTF-8");
            xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0);
            xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1);
            if (xml_parse_into_struct($parser, $resultDoc, $values, $tags))
            {
                if($values)
                {
                    $s_own_loc = 0;
                }
                xml_parser_free($parser);
                fclose($fp);
            }
        }
        return $s_own_loc;
    }

    /**
	* Check 123 FlashChat Data api
	* @parm $data_api   Chat Data Api
	* @return integer config status
	*/
    function validate_data_api($data_api)
    {   $da = 1;
        if(@file_get_contents($data_api))
        {
        	$da = 0;
    	}
        return $da;
    }
    
    /**
	* Check 123 FlashChat Client Location
	* @parm $client_loc   Chat Client Location
	* @return integer config status
	*/
    function validate_client($client_loc)
    {
		$c_own_loc = 1;
		$swf = $client_loc . '123flashchat.swf';
        if($headers = @get_headers($swf))
        {   
            $c_own_loc = (substr($headers[0], 9, 3) == '200') ? 0 : 1;
        }
        return $c_own_loc;
    }
}
?>
